// ColorSensor.js

(function(ext) {
    var device = null;
    
	var ports = {
		Port6:6,
		Port7:7,
		Port8:8,
		Port9:9,
		Port10:10
	};
    
	var components = {
		RED:1,
		GREEN:2,
		BLUE:3,
		CLEAR:7
	};
	
	ext.resetAll = function(){};
	
	ext.runArduino = function(){
		
	};
	ext.getRGBComponentScratch = function(port,RGBColorComponent) {
        device.send([port, RGBColorComponent])
    };
	var _level = 0;


    function processData(bytes) {
        trace(bytes);
    }

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('demo',function(data) {
            processData(data);
        });
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'demo disconnected'};
        return {status: 2, msg: 'demo connected'};
    }

    var descriptor = {};
	ScratchExtensions.register('RGBcolorSensor', descriptor, ext, {type: 'serial'});
})({});
